commit - b0e25f642db7b3e726f2827eb39b61bfea3e9c50
commit + 72f468914d4bb4efe0732ef75572d7dc7910e295
blob - 18dce1424914426c4a283effee2391af5dc10a53
blob + 9e90ab3973d15779dd8386d2fbf98d75958d17a2
--- lib/patch.c
+++ lib/patch.c
static const struct got_error *
apply_patch(struct got_worktree *worktree, struct got_repository *repo,
- const char *oldpath, const char *newpath, struct got_patch *p,
- int nop, struct patch_args *pa, got_cancel_cb cancel_cb, void *cancel_arg)
+ const char *old, const char *new, struct got_patch *p, int nop,
+ struct patch_args *pa, got_cancel_cb cancel_cb, void *cancel_arg)
{
const struct got_error *err = NULL;
struct got_pathlist_head oldpaths, newpaths;
struct got_pathlist_entry *pe;
int file_renamed = 0;
+ char *oldpath = NULL, *newpath = NULL;
char *tmppath = NULL, *template = NULL, *parent = NULL;;
FILE *tmp = NULL;
mode_t mode = GOT_DEFAULT_FILE_MODE;
TAILQ_INIT(&oldpaths);
TAILQ_INIT(&newpaths);
- err = got_pathlist_insert(&pe, &oldpaths, oldpath, NULL);
+ err = got_pathlist_insert(&pe, &oldpaths, old, NULL);
if (err)
goto done;
- err = got_pathlist_insert(&pe, &newpaths, newpath, NULL);
+ err = got_pathlist_insert(&pe, &newpaths, new, NULL);
if (err)
+ goto done;
+
+ if (asprintf(&oldpath, "%s/%s", got_worktree_get_root_path(worktree),
+ old) == -1) {
+ err = got_error_from_errno("asprintf");
goto done;
+ }
+ if (asprintf(&newpath, "%s/%s", got_worktree_get_root_path(worktree),
+ new) == -1) {
+ err = got_error_from_errno("asprintf");
+ goto done;
+ }
+
file_renamed = strcmp(oldpath, newpath);
if (asprintf(&template, "%s/got-patch",
if (err)
unlink(newpath);
} else
- err = report_progress(pa, oldpath, newpath, GOT_STATUS_MODIFY,
- NULL);
+ err = report_progress(pa, old, new, GOT_STATUS_MODIFY, NULL);
done:
got_pathlist_free(&oldpaths);
if (tmppath != NULL)
unlink(tmppath);
free(tmppath);
+ free(oldpath);
+ free(newpath);
return err;
}
blob - b3f10d2dc6e282f6548c695befab125a7f8f680e
blob + af1fd72e33001d46b8f822e0b0a7f00a5b1ad7b7
--- regress/cmdline/patch.sh
+++ regress/cmdline/patch.sh
fi
test_done $testroot 0
}
+
+test_patch_relative_paths() {
+ local testroot=`test_init patch_orig`
+
+ got checkout $testroot/repo $testroot/wt > /dev/null
+ ret=$?
+ if [ $ret -ne 0 ]; then
+ test_done $testroot $ret
+ return 1
+ fi
+ cat <<EOF > $testroot/wt/gamma/patch
+--- delta
++++ delta
+@@ -1 +1 @@
+-delta
++DELTA
+--- /dev/null
++++ eta
+@@ -0,0 +1 @@
++eta
+EOF
+
+ (cd $testroot/wt/gamma && got patch patch) > $testroot/stdout
+ ret=$?
+ if [ $ret -ne 0 ]; then
+ test_done $testroot $ret
+ return 1
+ fi
+
+ echo 'M gamma/delta' > $testroot/stdout.expected
+ echo 'A gamma/eta' >> $testroot/stdout.expected
+
+ cmp -s $testroot/stdout.expected $testroot/stdout
+ ret=$?
+ if [ $ret -ne 0 ]; then
+ diff -u $testroot/stdout.expected $testroot/stdout
+ fi
+ test_done $testroot $ret
+}
+
test_parseargs "$@"
run_test test_patch_simple_add_file
run_test test_patch_simple_rm_file
run_test test_patch_prefer_new_path
run_test test_patch_no_newline
run_test test_patch_strip
+run_test test_patch_relative_paths